
function adj_intensity(met)

  if nargin < 1,
    met ='init';
  end
  
  
  switch(met),
   case 'init',
    
    %hdr_name = sprintf('%s.hdr',fname);
    %img_name = sprintf('%s.img',fname);
  
    %hdr = read_analyze_hdr(hdr_name);
  
    %fp = fopen(
    
    h0 = figure(...
	'toolbar','none',...
	'menubar','none',...
	'name','Image Intensity Adjustment',...
	'numbertitle','off',...
	'windowbuttondownfcn','adj_intensity(''button_down'')',...
	'keypressfcn','adj_intensity(''key_down'')');
    pos = get(h0,'position');
    pos(3) = 570;
    pos(4) = 300;
    set(h0,'position',pos);
    data = [];
    userdata.data = data;
    userdata.winhandle = h0;
    set(1,'userdata',userdata);
    
   case 'button_down',
    a = get(1,'selectiontype');
    switch(a),
     case 'normal', % power toward 0.1
      % get userdata and see if there is any image display
      userdata = get(1,'userdata');
      if isempty(userdata.data),
	disp('No image loaded ...');
	return;
      end
      userdata.power = userdata.power-0.1;
      if userdata.power < 0.1,
	userdata.power = 0.1;
      end
      temp = userdata.data(:,:,userdata.shown_slice);
      temp = power(temp,userdata.power);
      subplot(1,2,2);
      imagesc(temp');
      axis image; axis off;
      set(1,'userdata',userdata);
      
     case 'alt', % power toward 2
      % get userdata and see if there is any image display
      userdata = get(1,'userdata');
      if isempty(userdata.data),
	disp('No image loaded ...');
	return;
      end
      userdata.power = userdata.power+0.1;
      if userdata.power > 2.0,
	userdata.power = 2.0;
      end
      temp = userdata.data(:,:,userdata.shown_slice);
      temp = power(temp,userdata.power);
      subplot(1,2,2);
      imagesc(temp');
      axis image; axis off;
      set(1,'userdata',userdata);
      
     case 'extend', %back to original
      % get userdata and see if there is any image display
      userdata = get(1,'userdata');
      if isempty(userdata.data),
	disp('No image loaded ...');
	return;
      end
      userdata.power = 1.0;
      temp = userdata.data(:,:,userdata.shown_slice);
      subplot(1,2,2);
      imagesc(temp');
      axis image; axis off;
      set(1,'userdata',userdata);
      
    end
    
    
   case 'key_down',
    a = get(1,'currentcharacter');
    switch(a),
     case 'o', % open image
      disp('Load image ...');
      [fname,pname] = uigetfile('*.img');
      ii = findstr(fname,'.');
      if ~isempty(ii),
	hdr_name = [pname fname(1:ii) 'hdr'];
      else
	hdr_name = [pname fname '.hdr'];
      end
      hdr = read_analyze_hdr(hdr_name);
      % check endian of the data file
      fp = fopen(hdr_name,'rb','ieee-le');
      temp = fread(fp,1,'uint16');
      fclose(fp);
      if temp > 348,
	open_method = 'ieee-be';
      else
	open_method = 'ieee-le';
      end
      
      % read in image
      img_name = [pname fname];
      fp = fopen(img_name,'rb',open_method);
      data = fread(fp,'uint16');
      fclose(fp);
      data = reshape(data,hdr.dim(2),hdr.dim(3),hdr.dim(4));
      
      % draw image
      userdata = get(1,'userdata');
      %axis(userdata.ax(1));
      subplot(1,2,1);
      shown_slice = floor(hdr.dim(4)/2);
      imagesc(data(:,:,shown_slice)');
      colormap(gray);
      axis image; axis off;
      subplot(1,2,2);
      imagesc(data(:,:,shown_slice)');
      colormap(gray);
      axis image; axis off;
      
      % save useful info in userdata
      userdata.data = data;
      userdata.hdr = hdr;
      userdata.open_method = open_method;
      userdata.shown_slice = shown_slice;
      userdata.power = 1;
      userdata.img_name = img_name;
      userdata.hdr_name = hdr_name;
      userdata.max = max(data(:));
      userdata.min = min(data(:));
      set(1,'userdata',userdata);
      
     case 'l', % display lower one slice
      % get userdata and see if there is any image display
      userdata = get(1,'userdata');
      if isempty(userdata.data),
	disp('No image loaded ...');
	return;
      end
      userdata.shown_slice = userdata.shown_slice -1;
      if userdata.shown_slice < 1
	userdata.shown_slice = 1;
      end
      temp = userdata.data(:,:,userdata.shown_slice);
      subplot(1,2,1);
      imagesc(temp');
      axis image; axis off;
      temp = power(temp,userdata.power);
      subplot(1,2,2);
      imagesc(temp');
      axis image; axis off;
      set(1,'userdata',userdata);
      
     case 'u', % display higher one slice
      % get userdata and see if there is any image display
      userdata = get(1,'userdata');
      if isempty(userdata.data),
	disp('No image loaded ...');
	return;
      end
      userdata.shown_slice = userdata.shown_slice +1;
      if userdata.shown_slice > userdata.hdr.dim(4),
	userdata.shown_slice = userdata.hdr.dim(4);
      end
      temp = userdata.data(:,:,userdata.shown_slice);
      subplot(1,2,1);
      imagesc(temp');
      axis image; axis off;
      temp = power(temp,userdata.power);
      subplot(1,2,2);
      imagesc(temp');
      axis image; axis off;
      set(1,'userdata',userdata);
      
     case 'd' %done
      userdata = get(1,'userdata');
      if isempty(userdata.data),
	disp('No image loaded ...');
	return;
      end

      disp('Writing image ...');
      set(userdata.winhandle,'pointer','watch');
      userdata.data = power(userdata.data,userdata.power);
      userdata.data = fmrlab_scale(userdata.data,userdata.min,userdata.max);
      userdata.data = uint16(userdata.data);
      fp = fopen(userdata.img_name,'wb',userdata.open_method);
      fwrite(fp,userdata.data,'uint16');
      fclose(fp);
      
      fp1 = fopen(userdata.hdr_name,'rb',userdata.open_method);
      fp2 = fopen('temp.hdr','wb',userdata.open_method);
      a = fgets(fp1,40);
      fwrite(fp2,a,'char');
      dim = uint16(userdata.hdr.dim);
      fwrite(fp2,dim,'uint16');
      fseek(fp1,16,0);
      while(1),
	a = fgets(fp1,1);
	fwrite(fp2,a,'char');
	if ftell(fp) == 348,
	  break;
	end
      end
      fclose(fp1);
      fclose(fp2);
      
      set(userdata.winhandle,'pointer','arrow');
      delete(userdata.winhandle);
      
     case 'r', % rotate images
      userdata = get(1,'userdata');
      if isempty(userdata.data),
	disp('No image loaded ...');
	return;
      end
      
      disp('Rotate image colokwise ...');
      
     case '1', % exchange z-axis to the first axis in data
      userdata = get(1,'userdata');
      if isempty(userdata.data),
	disp('No image loaded ...');
	return;
      end
      
      data = zeros(userdata.hdr.dim(3),...
		   userdata.hdr.dim(4),...
		   userdata.hdr.dim(2));
      for ii=1:userdata.hdr.dim(2),
	temp = squeeze(userdata.data(ii,:,:));
	data(:,:,ii) = temp;
      end
      userdata.data = data;
      temp = userdata.hdr.dim(2);
      userdata.hdr.dim(2) = userdata.hdr.dim(3);
      userdata.hdr.dim(3) = userdata.hdr.dim(4);
      userdata.hdr.dim(4) = temp;
      temp = userdata.data(:,:,userdata.shown_slice);
      subplot(1,2,1);
      imagesc(temp');
      axis image; axis off;
      subplot(1,2,2);
      temp = power(temp,userdata.power);
      imagesc(temp');
      axis image; axis off;
      
      set(1,'userdata',userdata);
      
     case '2', % exchange z-axis to the second axis in data
      userdata = get(1,'userdata');
      if isempty(userdata.data),
	disp('No image loaded ...');
	return;
      end
      
     case '3', % exchange z-axis to the third axis in data
               % (default)
      userdata = get(1,'userdata');
      if isempty(userdata.data),
	disp('No image loaded ...');
	return;
      end	       
      
    end
    
    
  end
