function batch_sumup_brainareas(z_thre, stat_name, out_name)

if nargin < 1,
  z_thre = 2.0;
end
if nargin < 2,
  stat_name = 'temp.txt';
end
if nargin < 3,
  out_name = 'areas.txt';
end

a = spm_get([],'w*.img','Select Statistical Result Images');
vol2check = spm_read_vols(spm_vol(a));
size(vol2check);

addpath('/home/duann/matlab/spm2/toolbox/WFU_PickAtlas');
b = wfu_pickatlastype;
[Atlas]=wfu_get_atlas_list(b.subdir,b.lookupfile,b.dispimage);

sz = size(vol2check);
if length(sz) < 4,
  sz = [sz 1];
end

% read in timing info
fp = fopen(stat_name,'r');
for i=1:sz(4),
  if feof(fp),
    disp('not enough timing info provided ...');
    disp(['please check ' stat_name]);
    return;
  end
  t_info{i} = fgets(fp);
end

outfp = fopen(out_name,'w');
current_dir = eval('pwd');
fprintf(outfp,'%s\n',current_dir);

for i=1:sz(4)
  tt = a(i,:);
  ii = findstr(tt,'.img');
  fname = [tt(1:ii) 'txt'];
  fp = fopen(fname,'w');
  for j=1:sz(3),
    temp = vol2check(:,:,j,i);
    temp = squeeze(temp);
    [x,y] = find(abs(temp)>z_thre);
    vp = round([x(:) y(:) ones(length(x),1)*j]);
    for k=1:size(vp,1),
      val = Atlas(4).Atlas(vp(k,1),vp(k,2),vp(k,3));
      c = find(Atlas(4).Region.SubregionValues==val);
      val2 = Atlas(1).Atlas(vp(k,1),vp(k,2),vp(k,3));
      c2 = find(Atlas(1).Region.SubregionValues==val2);
      if length(c) ~= 0,
        b = char(Atlas(4).Region.SubregionNames(c));
        if vp(k,1)<=45,
          fprintf(fp,'z(%d,%d,%d)=%8.4f : L. %s (',vp(k,1),vp(k,2),vp(k,3),vol2check(vp(k,1),vp(k,2),vp(k,3),i),b);
        else
          fprintf(fp,'z(%d,%d,%d)=%8.4f : R. %s (',vp(k,1),vp(k,2),vp(k,3),vol2check(vp(k,1),vp(k,2),vp(k,3),i),b);
        end
        if length(c2) == 0,
          fprintf(fp,'N/A)\n');
        else
          b = char(Atlas(1).Region.SubregionNames(c2));
          fprintf(fp,'%s)\n',b);
        end
      end
    end
  end
  fclose(fp);

  % running sumup_brain_area here
  fp = fopen(fname,'r');
  % get the z-value brain area name for each entry
  z = [];
  ar = {''};
  loc = {''};
  cnt = 1;
  while ~feof(fp),
    a1 = fgets(fp);
    kk1 = findstr(a1,'(');
    kk2 = findstr(a1,')');
    ii = findstr(a1,'=');
    jj = findstr(a1,':');
    zz = str2num(a1(ii+1:jj-1));
    if abs(zz) >= z_thre,
      z(cnt) = str2num(a1(ii+1:jj-1));
      ar{cnt} = a1(jj+2:length(a1)-1);
      loc{cnt} = a1(kk1:kk2);
      cnt = cnt + 1;
    end
  end
  fclose(fp);
 
  cnt = cnt-1;
  class_cnt = 1;
  cl(1).name = ar{1};
  ii = find(strcmp(ar,cl(1).name));
  [x,y] = max(abs(z(ii)));
  cl(1).z = z(ii(y));
  cl(1).loc = loc(ii(y));
  for k=2:cnt,
    found = 0;
    for j=1:class_cnt,
      if strcmp(cl(j).name,ar{k}) == 1,
        found = 1;
      end
    end
    if found == 0,
      class_cnt = class_cnt + 1;
      cl(class_cnt).name = ar{k};
      ii = find(strcmp(ar,cl(class_cnt).name));
      [x,y] = max(abs(z(ii)));
      cl(class_cnt).z = z(ii(y));
      cl(class_cnt).loc = loc{ii(y)};
    end
  end 
  
  % write summary
  
  fprintf(outfp,'%s',t_info{i});
  for k=1:class_cnt,
    fprintf(outfp,'%s; %8.4f; %s\n',char(cl(k).loc),cl(k).z,cl(k).name);
  end
  
  fprintf(1,'%s finished ...\n',tt);
end

fclose(outfp);