
% 2006-09-22
% program estimating the translations and rotations according to 
% FSL:flirt result.
%
% Syntax: [x,y,z,pitch,roll,yaw]=flirt_summ(pre_file, fileno);
%
% Input: 
%   pre_file - prefix of file name (e.g., 'run1_mc_') 
%   fileno   - starting and ending file numbers (e.g., [1 235])
%
% Author: Jeng-Ren Duann, PhD, INC/UCSD, 2006-09-22

function [x,y,z,pitch,roll,yaw]=flirt_summ(pre_file, fileno)

x = zeros(1,fileno(2)-fileno(1)+1);
y = zeros(1,fileno(2)-fileno(1)+1);
z = zeros(1,fileno(2)-fileno(1)+1);
pitch = zeros(1,fileno(2)-fileno(1)+1);
roll = zeros(1,fileno(2)-fileno(1)+1);
yaw = zeros(1,fileno(2)-fileno(1)+1);

cnt = 1;
for i=fileno(1):fileno(2)
  fname = sprintf('%s%04d.mat',pre_file,i);
  M = load(fname,'-ascii');
  P = spm_imatrix(M);
  x(cnt) = P(1);
  y(cnt) = P(2);
  z(cnt) = P(3);
  pitch(cnt) = P(4);
  roll(cnt) = P(5);
  yaw(cnt) = P(6);
  cnt = cnt +1;
end

figure
subplot(2,1,1);
plot([x;y;z]');
legend('x','y','z');
title(pre_file);
subplot(2,1,2);
plot([pitch;roll;yaw]');
legend('pitch','roll','yaw');