function fmrlab_export_result(met)

global FMRI

if nargin < 1,
    disp('Usage: adj_str_img(met);');
    met = 'init';
end

if strcmp(met,'init')==1,
    h = figure;
    pos = get(h,'position');
    % create buttons
    pos2 = [10+pos(3)/2 pos(4)/2-30 120 25];
    uicontrol('parent',h,'position',pos2,'style','togglebutton',...
        'fontweight','bold','tag','tg_degree','string','90',...
        'callback','adj_str_img(FMRI,''toggle'');');
    pos2(2) = pos2(2)-30;
    uicontrol(...
            'parent',h,...
            'position',pos2,...
            'style','pushbutton',...
            'string','Rotate about x',...
            'fontweight','bold',...
            'tag','bt_rotate_x',...
            'callback','adj_str_img(''rotate_x'');');
    pos2(2) = pos2(2)-30;
    uicontrol(...
            'parent',h,...
            'position',pos2,...
            'style','pushbutton',...
            'string','Rotate about y',...
            'fontweight','bold',...
            'tag','bt_rotate_y',...
            'callback','adj_str_img(''rotate_y'');');
    pos2(2) = pos2(2)-30;
    uicontrol(...
            'parent',h,...
            'position',pos2,...
            'style','pushbutton',...
            'string','Rotate about z',...
            'fontweight','bold',...
            'tag','bt_rotate_z',...
            'callback','adj_str_img(''rotate_z'');');
    pos2(2) = pos2(2)-60;
    uicontrol(...
            'parent',h,...
            'position',pos2,...
            'style','pushbutton',...
            'string','Flip about y',...
            'fontweight','bold',...
            'tag','bt_flip_y',...
            'callback','adj_str_img(''flip_y'');');  
    pos2(1) = pos2(1)+140;
    uicontrol(...
            'parent',h,...
            'position',pos2,...
            'style','pushbutton',...
            'string','Cancel',...
            'fontweight','bold',...
            'tag','bt_flip_y',...
            'callback','adj_str_img(''cancel'');');    
    pos2(2) = pos2(2)+30;
    uicontrol(...
            'parent',h,...
            'position',pos2,...
            'style','pushbutton',...
            'string','OK',...
            'fontweight','bold',...
            'tag','bt_flip_y',...
            'callback','adj_str_img(''OK'');'); 
    temp = zeros(1,FMRI.dime_x*FMRI.dime_y*FMRI.dime_z);
    temp2 = mean(FMRI.data);
    for i=1:length(FMRI.idx),
        temp(FMRI.idx(i)) = temp2(i);
    end
    temp = reshape(temp,FMRI.dime_x,FMRI.dime_y,FMRI.dime_z);
    
    im = zeros(1,3);
    im(1) = axes('position',[0 0.5 0.5 0.5],...
        'xtick',[],'ytick',[],'xticklabel',[],'yticklabel',[],'color','k');
    im(2) = axes('position',[0.5 0.5 0.5 0.5],...
        'xtick',[],'ytick',[],'xticklabel',[],'yticklabel',[],'color','k');
    im(3) = axes('position',[0 0 0.5 0.5],...
        'xtick',[],'ytick',[],'xticklabel',[],'yticklabel',[],'color','k');
    userdata.im = im;
    userdata.imdata = temp;
    userdata.process_step = 0;
    userdata.processes = '';
    set(h,'userdata',userdata);
    display_str_images;
    
elseif strcmp(met,'rotate_x')==1,
    a = findobj(gcf,'tag','tg_degree');
    b = get(a,'value');
    userdata = get(gcf,'userdata');
    temp = userdata.imdata;
    b = 2*b-1;
    new_temp = rotx90(temp,b);
    userdata.imdata = new_temp;
    userdata.process_step = userdata.process_step+1;
    userdata.processes{userdata.process_step} = ['x:' num2str(b)];
    set(gcf,'userdata',userdata);
    display_str_images;
    
elseif strcmp(met,'rotate_y')==1,
    a = findobj(gcf,'tag','tg_degree');
    b = get(a,'value');
    userdata = get(gcf,'userdata');
    temp = userdata.imdata;
    b = 2*b-1;
    new_temp=roty90(temp,b);
    userdata.imdata = new_temp;
    userdata.process_step = userdata.process_step+1;
    userdata.processes{userdata.process_step} = ['y:' num2str(b)];
    set(gcf,'userdata',userdata);
    display_str_images;
    
elseif strcmp(met,'rotate_z')==1,
    a = findobj(gcf,'tag','tg_degree');
    b = get(a,'value');
    userdata = get(gcf,'userdata');
    temp = userdata.imdata;
    b = 2*b-1;
    new_temp = rotz90(temp,b);
    userdata.imdata = new_temp;
    userdata.process_step = userdata.process_step+1;
    userdata.processes{userdata.process_step} = ['z:' num2str(b)];
    set(gcf,'userdata',userdata);
    display_str_images;
    
elseif strcmp(met,'toggle')==1,
    a = findobj(gcf,'tag','tg_degree');
    b = get(a,'value');
    if b==1,
        set(a,'string','-90');
    else
        set(a,'string','90');
    end
    
elseif strcmp(met,'flip_y') == 1,
    userdata = get(gcf,'userdata');
    temp = userdata.imdata;
    new_temp = flipy(temp);
    userdata.imdata = new_temp;
    userdata.process_step = userdata.process_step+1;
    userdata.processes{userdata.process_step} = 'y:0';
    set(gcf,'userdata',userdata);
    display_str_images;
    
elseif strcmp(met,'cancel')==1,
    close;
    
elseif strcmp(met,'OK')==1,
    disp('export component maps as analyze format images');
    % write str_0001.img first
    userdata = get(gcf,'userdata');
    hdr.data = userdata.imdata;
    hdr.datatype = 4; % for float
    hdr.imagewidth = size(userdata.imdata,1);
    hdr.imageheight = size(userdata.imdata,2);
    hdr.imagedepth = size(userdata.imdata,3);
    hdr.volsizex = FMRI.fov_x / FMRI.dime_x;
    hdr.volsizey = FMRI.fov_y / FMRI.dime_y;
    hdr.volsizez = FMRI.slicetk;
    write_analyze(FMRI,'str_0001',hdr);
    % write each of the component maps selected in FMRI.icacomp
    W = FMRI.icaweight*FMRI.icasphere;
    u = W * FMRI.data;
    for i=1:length(FMRI.icacomp),
        temp = u(FMRI.icacomp(i),:);
        temp = (temp-mean(temp))/std(temp);
        imdata = zeros(1,FMRI.dime_x*FMRI.dime_y*FMRI.dime_z);
        for j=1:length(FMRI.idx),
            imdata(FMRI.idx(j)) = temp(j);
        end
        temp = reshape(imdata,FMRI.dime_x,FMRI.dime_y,FMRI.dime_z);
        for j=1:userdata.process_step,
            s = userdata.processes{j};
            ii = findstr(s,':');
            s1 = s(1:ii-1);
            s2 = str2num(s(ii+1:length(s)));
            switch s1,
                case 'x',
                    temp = rotx90(temp,s2);
                case 'z',
                    temp = rotz90(temp,s2);
                case 'y',
                    if s2==0,
                        temp = flipy(temp);
                    else
                        temp = roty90(temp,s2);
                    end
            end
        end
        hdr.data = temp;
        hdr.datatype = 16; % for float
        hdr.imagewidth = size(temp,1);
        hdr.imageheight = size(temp,2);
        hdr.imagedepth = size(temp,3);
        hdr.volsizex = FMRI.fov_x / FMRI.dime_x;
        hdr.volsizey = FMRI.fov_y / FMRI.dime_y;
        hdr.volsizez = FMRI.slicetk;
        ftemp = sprintf('roa_%04d',FMRI.icacomp(i));
        write_analyze(FMRI,ftemp,hdr);
    end
    close;
end

function im = rotx90(im,n)
% im = 3D image data
% n = n*90 degree (n can be +/-1)
sz = size(im);
new_temp = zeros(sz(1),sz(3),sz(2));
for i=1:sz(1),
    temp2 = squeeze(im(i,:,:));
    temp3 = rot90(temp2,n);
    new_temp(i,:,:) = temp3;
end
im = new_temp;
return

function im = roty90(im,n)
% im = 3D image data
% n = n*90 degree (n can be +/-1)
sz = size(im);
new_temp = zeros(sz(3),sz(2),sz(1));
for i=1:sz(2),
    temp2 = squeeze(im(:,i,:));
    temp3 = rot90(temp2,n);
    new_temp(:,i,:) = temp3;
end
im = new_temp;
return;

function im = rotz90(im,n)
% im = 3D image data
% n = n*90 degree (n can be +/-1)
sz = size(im);
new_temp = zeros(sz(2),sz(1),sz(3));
for i=1:sz(3),
    temp2 = squeeze(im(:,:,i));
    temp3 = rot90(temp2,n);
    new_temp(:,:,i) = temp3;
end
im = new_temp;
return;

function im = flipy(im)
% im = 3D image data
sz = size(im);
new_temp = zeros(sz(1),sz(2),sz(3));
for i=1:sz(3),
    temp2 = squeeze(im(:,:,i));
    temp2 = flipud(temp2);
    new_temp(:,:,i) = temp2;
end
im = new_temp;
return;

function write_analyze(FMRI,file_temp, content)
  disp(['Writing ' file_temp '.img ...']);
  fname = [file_temp '.img'];
  fp = fopen(fname,'wb','ieee-be');
  if fp == -1,
    %errordlg('Cannot open image file ...!');
    fmrlab_messagedlg('Export Results',...
		  'Error:',...
		  'Cannot open image file');
    return;
  end
  switch content.datatype,
   case 4,
    fwrite(fp,content.data,'int16');
   case 8,
    fwrite(fp,content.data,'int32');
   case 16,
    fwrite(fp,content.data,'float');
   case 32,
    fwrite(fp,content.data,'double');
  end
  fclose(fp);
  
  disp(['Writing ' file_temp '.hdr ...']);
  fname = [file_temp '.hdr'];
  fp = fopen(fname, 'wb','ieee-be');
  if fp == -1,
    %errordlg('Cannot open header file...!');
    fmrlab_messagedlg('Export Results',...
		  'Error:',...
		  'Cannot open header file');
    return;
  end
  if length(FMRI.struc_path) < 18,
    db_name = FMRI.struc_path;
    while length(db_name) < 18,
      db_name = [db_name 0];
    end
  else
    ss = length(FMRI.struc_path)-18;
    ee = length(FMRI.struc_path)-1;
    db_name = FMRI.struc_path(ss:ee);
  end  
  data_type = ['dsr      ' 0];
  DESCRIP = 'spm compatible';
  descrip = zeros(1, 80);
  d = 1:length(DESCRIP);
  descrip(d) = DESCRIP(d);
  aux_file = ['none                   ' 0];
  origin = [0 0 0 0 0];
  if content.datatype == 4,
    bitpix = 16;
  else
    bitpix = 32;
  end
  glmax = 32767;
  glmin = 0;
  vox_offset = 0;
  funused1 = 1; %Scale factor
  dim = [4 content.imagewidth content.imageheight ...
	 content.imagedepth 1 0 0 0];
  pixdim = [0 content.volsizex content.volsizey content.volsizez 0 0 0 0];
  orientation = char(3);
  
  % write (struct) header_key
  %--------------------------------------------------------------------
  fwrite(fp, 348, 'int32');		%sizeof_hdr
  fwrite(fp, data_type, 'char');	%data_type
  fwrite(fp, db_name, 'char');	%db_name
  fwrite(fp, 0, 'int32');		%extents
  fwrite(fp, 0, 'int16');		%session_error
  fwrite(fp, 'r', 'char');		%regular
  fwrite(fp, '0', 'char');		%hkey_un0
  % write (struct) image_dimension
  %--------------------------------------------------------------------
  fwrite(fp, dim, 'int16');		%short int dim[8]
  fwrite(fp, 'mm', 'char');		%char vox_units[4]
  fwrite(fp, 0, 'char');
  fwrite(fp, 0, 'char');
  fwrite(fp, zeros(1, 8), 'char');  %char cal_units[8]
  fwrite(fp, 0, 'int16');		%short int unused1
  fwrite(fp, content.datatype, 'int16');	%short int datatype
  fwrite(fp, bitpix, 'int16');	%short int bitpix
  fwrite(fp, 0, 'int16');		%short int dim_un0
  fwrite(fp, pixdim, 'float');	%float pixdim[8]
  fwrite(fp, vox_offset, 'float');  %float vox_offset
  fwrite(fp, funused1, 'float');	%float funused1 (scale factor)
  fwrite(fp, 0, 'float');		%float funused2
  fwrite(fp, 0, 'float');		%float funused3
  fwrite(fp, 0, 'float');		%float cal_max
  fwrite(fp, 0, 'float');		%float cal_min
  fwrite(fp, 0, 'int32');		%int compressed
  fwrite(fp, 0, 'int32');		%int verified
  fwrite(fp,glmax,	'int32');	%int glmax
  fwrite(fp,glmin,	'int32');	%int glmin
  %write (struct) data_history
  %-------------------------------------------------------------------
  fwrite(fp, descrip, 'char');	%char descrip[80]
  fwrite(fp, aux_file, 'char');	%char aux_file[24]
  fwrite(fp, orientation, 'char');	%char orient
  fwrite(fp, origin, 'int16');	%short int origin[5]
  fwrite(fp, zeros(1, 85), 'char');
  %-------------------------------------------------------------------
  fclose(fp);
  
  return;

function display_str_images()
userdata = get(gcf,'userdata');
im = userdata.im;
temp = userdata.imdata;
sz = size(temp);
axes(im(1));
temp2 = squeeze(temp(:,:,round(sz(3)/2)));
imagesc(temp2');
axis off
colormap(gray);
ln = line([5 12],[5 5]);
set(ln,'color','r');
tx = text(15,5,'x');
set(tx,'color','r');
ln = line([5 5],[5 12]);
set(ln,'color','r');
tx = text(5,15,'y');
set(tx,'color','r');

axes(im(2));
temp2 = squeeze(temp(:,round(sz(2)/2),:));
imagesc(temp2');
axis off
colormap(gray);
ln = line([5 12],[5 5]);
set(ln,'color','r');
tx = text(15,5,'x');
set(tx,'color','r');
ln = line([5 5],[5 12]);
set(ln,'color','r');
tx = text(5,15,'z');
set(tx,'color','r');

axes(im(3));
temp2 = squeeze(temp(round(sz(1)/2),:,:));
imagesc(temp2');
axis off
colormap(gray);
ln = line([5 12],[5 5]);
set(ln,'color','r');
tx = text(15,5,'y');
set(tx,'color','r');
ln = line([5 5],[5 12]);
set(ln,'color','r');
tx = text(5,15,'z');
set(tx,'color','r');
