function fmrlab_import_ref()
  
% launch file selection window for users to select reference
% function file
    
global FMRI
  
[fname,pname] = uigetfile({'*.txt','Ref Func. Text File'},['Import Ref' ...
		    ' Func.']);
fp = fopen([pname fname],'r');
ref = fscanf(fp,'%f');
fclose(fp);

% first check if the reference function has the same number of time
% points as input data, FMRI.data
if length(ref) ~= min(size(FMRI.data))
  fmrlab_messagedlg('Import Ref. Func.',...
		    'Error:',...
		    'Invalid length of reference function');
  return;
end

% check if there is reference existing already
if length(FMRI.ref) ~= 0,
  ret = fmrlab_messagedlg('Import Ref. Func.',...
		    'Error:',...
		    'Ref. func. exists, overwrite?',...
		    {'Yes','No'});
  if strcmp(ret,'Yes'),
    FMRI.ref = ref;
  end
else
  FMRI.ref = ref;
end
