% fmrlab_label_comps_compact() - select meaningful components using the compactness
%                                measures of the component maps.
%
% Author: Jeng-Ren Duann PhD (duann@sccn.ucsd.edu), INC/UCSD, 2007/05/11
%

function fmrlab_label_comps_compact()

global FMRI

if isempty('FMRI'),
  fmrlab_messagedlg('FMRI data set not available ...',...
    'Error',...
    'Please load FMRI data set before launch this function.',...
    {'OK'});
  return;
end

ii = fmrlab_ica_connectivity(FMRI);
FMRI.icacomp = find(ii>0);
FMRI.rejcomp = find(ii==0);
show_parameters;
