function fmrlab_list_brain_areas(thre)

if nargin < 1,
  thre = 2.0;
end

a = spm_get([],'w*.img','Select Statistical Result Images');
vol2check = spm_read_vols(spm_vol(a));
size(vol2check);

addpath('/home/duann/matlab/spm2/toolbox/WFU_PickAtlas');
b = wfu_pickatlastype;
[Atlas]=wfu_get_atlas_list(b.subdir,b.lookupfile,b.dispimage);

sz = size(vol2check);
if length(sz) < 4,
  sz = [sz 1];
end
for i=1:sz(4)
  tt = a(i,:);
  ii = findstr(tt,'.img');
  fname = [tt(1:ii) 'txt'];
  fp = fopen(fname,'w');
  for j=1:sz(3),
    temp = vol2check(:,:,j,i);
    temp = squeeze(temp);
    [x,y] = find(abs(temp)>thre);
    vp = round([x(:) y(:) ones(length(x),1)*j]);
    for k=1:size(vp,1),
      val = Atlas(4).Atlas(vp(k,1),vp(k,2),vp(k,3));
      c = find(Atlas(4).Region.SubregionValues==val);
      val2 = Atlas(1).Atlas(vp(k,1),vp(k,2),vp(k,3));
      c2 = find(Atlas(1).Region.SubregionValues==val2);
      if length(c) ~= 0,
        b = char(Atlas(4).Region.SubregionNames(c));
        if vp(k,1)<=45,
          fprintf(fp,'z(%d,%d,%d)=%8.4f : L. %s (',vp(k,1),vp(k,2),vp(k,3),vol2check(vp(k,1),vp(k,2),vp(k,3),i),b);
        else
          fprintf(fp,'z(%d,%d,%d)=%8.4f : R. %s (',vp(k,1),vp(k,2),vp(k,3),vol2check(vp(k,1),vp(k,2),vp(k,3),i),b);
        end
        if length(c2) == 0,
          fprintf(fp,'N/A)\n');
        else
          b = char(Atlas(1).Region.SubregionNames(c2));
          fprintf(fp,'%s)\n',b);
        end
      end
    end
  end
  fclose(fp);
  fprintf(1,'%s finished ...\n',tt);
end


