function mdl = fmrlab_mdl()

global FMRI
voxel_no = size(FMRI.data,2);
time_point = size(FMRI.data,1);

[e,v] = pcsquash(FMRI.data);
mdl = zeros(1,time_point-1);
for i=1:time_point-1,
  % calculate L(theta)
  l1 = 1;
  for j=i+1:time_point,
    l1 = l1 * v(j);
  end
  l2 = 0;
  for j=i+1:time_point,
    l2 = l2 + v(j);
  end
  ll = log(power(l1,1/(time_point-i)))/(l2/(time_point-i));
  mdl(i) = -1*voxel_no*(time_point-i)*ll + 0.5*log(voxel_no)*(1+i+(i-1)/2);
end
