function th=fmrlab_roa_thre(comp,fig)

% input
%    comp - component no.
%    fig  - fig no. to display the result
%
% output
%    th - ROA threshold (in % of voxels)

global FMRI

W = FMRI.icaweight*FMRI.icasphere;
invW = pinv(W);
u = W * FMRI.data;
data2 = invW(:,comp)*u(comp,:);
pp = [];
for i=1:size(data2,2),
  pp = [pp sum(abs(data2(:,i)))];
end
pp2 = sort(pp);
th = 25*mean(pp2(1:round(size(data2,2)/5)));
ii = find(pp2>th);
if fig ~=0,
  figure(fig)
  clf
  plot(pp2);
  hold on
  plot(ii(1),pp2(ii(1)),'ro');
  title(num2str(length(ii)/size(data2,2)));
end
th = length(ii)/size(data2,2);