% find each voxel three components, which contribute maximally to 
% its activity
W = FMRI.icaweight * FMRI.icasphere;
u = W *FMRI.data;
fea = [];
for i=1:size(u,2),
  [temp,j] = sort(u(:,i));
  fea = [fea; j(size(u,1)-2:size(u,1))'];
end

figure
for i=1:3,
  temp = fea(:,i);
  temp2 = zeros(1,FMRI.dime_x*FMRI.dime_y*FMRI.dime_z);
  for j=1:length(FMRI.idx),
    temp2(FMRI.idx(j)) = temp(j);
  end
  temp2 = reshape(temp2,FMRI.dime_x,FMRI.dime_y,FMRI.dime_z);
  subplot(2,2,i);
  imagesc(temp2(:,:,round(FMRI.dime_z/2))');
  cbar;
end

% check connectivty
conn = zeros(size(temp2));
% deal with the first and last slices
cnt = 0;
for i=1:length(FMRI.idx),
  % convert idx to x-,y-,z-coordinates
  zz = fix(FMRI.idx(i)/FMRI.dime_x/FMRI.dime_y)+1;
  idx_zz = mod(FMRI.idx(i),64*64);
  xx = mod(idx_zz,FMRI.dime_x);
  yy = fix(idx_zz/FMRI.dime_x)+1;
  % make a template for 17-neighborhood because of 1st slice
  temp3 = zeros(size(temp2));
  if zz == 1, % the first slice
    temp3(xx-1:xx+1,yy-1:yy+1,zz:zz+1) = 1;
    ii = find(temp3==1);
    ii = find(temp2(ii) == temp2(FMRI.idx(i)));
    if length(ii) > 6,
      conn(FMRI.idx(i)) = temp2(FMRI.idx(i));
    end
  elseif zz == FMRI.dime_z, % the last slice
    temp3(xx-1:xx+1,yy-1:yy+1,zz-1:zz) = 1;
    ii = find(temp3==1);
    ii = find(temp2(ii) == temp2(FMRI.idx(i)));
    if length(ii) > 6,
      conn(FMRI.idx(i)) = temp2(FMRI.idx(i));
    end
  else
    temp3(xx-1:xx+1,yy-1:yy+1,zz-1:zz+1) = 1;
    ii = find(temp3==1);
    ii = find(temp2(ii) == temp2(FMRI.idx(i)));
    if length(ii) > 9,
      conn(FMRI.idx(i)) = temp2(FMRI.idx(i));
    end
  end % of if zz 

  if mod(i,1000) == 0,
    disp([num2str(i) '/' num2str(length(FMRI.idx)) ' is done...']);
  end
end % of for i

ii = find(conn ~= 0);
n = histc(conn(ii),1:150);
% n gives us the number of voxels corresponding to each comp.
% spatial extent criterion can be used here to further screen
% for the comp of interest
clf
plot(n);
hold on
ii = find(n>10);
plot(ii,n(ii),'gx');
plot(FMRI.icacomp,n(FMRI.icacomp),'ro');
legend('connectivity','spatial extent > 10','comp of interest');
