function [ccmapt,ccmaps] = intra_decomp_corr()

global FMRI

ccmapt = zeros(FMRI.pcano,FMRI.pcano);
ccmaps = zeros(FMRI.pcano,FMRI.pcano);

% calculating corrcoef in time domain
W = FMRI.icaweight * FMRI.icasphere;
invW = pinv(W);
for i = 1:FMRI.pcano,
  for j = 1:FMRI.pcano,
    if i ~= j,
      a = invW(:,i);
      a = (a - mean(a))/std(a);
      b = invW(:,j);
      b = (b - mean(b))/std(b);
      temp = corrcoef(a,b);
      ccmapt(i,j) = temp(1,2);
    end
  end
end

% calculating corrcoef in spatial domain
u = W * FMRI.data;
for i=1:FMRI.pcano,
  for j=1:FMRI.pcano,
    if i~=j,
      a = u(i,:)';
      a = (a-mean(a))/std(a);
      b = u(j,:)';
      b = (b-mean(b))/std(b);
      temp = corrcoef(a,b);
      ccmaps(i,j) = temp(1,2);
    end
  end
end

