function [cvmapt,cvmaps] = intra_decomp_cov()

global FMRI

cvmapt = zeros(FMRI.pcano,FMRI.pcano);
cvmaps = zeros(FMRI.pcano,FMRI.pcano);

% calculating corrcoef in time domain
W = FMRI.icaweight * FMRI.icasphere;
invW = pinv(W);
for i = 1:FMRI.pcano,
  for j = 1:FMRI.pcano,
    if i ~= j,
      a = invW(:,i);
      %a = (a - mean(a))/std(a);
      b = invW(:,j);
      %b = (b - mean(b))/std(b);
      temp = cov(a,b);
      cvmapt(i,j) = temp(1,2);
    end
  end
end

% calculating corrcoef in spatial domain
u = W * FMRI.data;
for i=1:FMRI.pcano,
  for j=1:FMRI.pcano,
    if i~=j,
      a = u(i,:)';
      %a = (a-mean(a))/std(a);
      b = u(j,:)';
      %b = (b-mean(b))/std(b);
      temp = cov(a,b);
      cvmaps(i,j) = temp(1,2);
    end
  end
end

