function mk_freesurfer_blobs(file_temp, new_file_temp)

% usage: mk_freesurfer_blobs(file_temp, new_file_temp);
% 
% This program is made to convert the spm T images to 
% what acceptable by freesurfer program. The argument
% of file_temp gives the file name (with no extension)
% of the image file you would like to convert. 'new_file_temp'
% gives the file name you would like to save.
%
% Jeng-Ren Duann, 2006-03-08
%

if nargin < 2,
  disp('Usage: mk_freesurfer_blobs(file_temp, new_file_temp)');
  exit;
end

fname = [file_temp '.img'];
v = spm_vol(fname);
[y,xyz]=spm_read_vols(v);
%y = y * v.pinfo(1)+v.pinfo(2);
v.private.hdr.dime.datatype = 16;
%v.private.hdr.dime.glmax = max(y(:));
%v.private.hdr.dime.glmin = min(y(:));
%v.pinfo(1) = 1;
%v.pinfo(2) = 0;
v.fname = [new_file_temp '.img'];
spm_write_vol(v,y);
